#
# Conditional build:
%bcond_with	glide3_sdk	# build glide3x SDK here (normally built from Glide_V5-DRI.spec)
#
%define snapdate 20010309
%define	rel	17
Summary:	Glide runtime for 3Dfx Voodoo Banshee and Voodoo3 boards
Summary(ko.UTF-8):	3Dfx 부두 벤쉬/3 비디오카드용 Glide 런타임 라이브러리
Summary(pl.UTF-8):	Biblioteki Glide dla kart 3Dfx Voodoo Banshee oraz Voodoo3
Name:		Glide_V3-DRI
Version:	3.10.0
Release:	0.%{snapdate}.%{rel}
Epoch:		1
License:	3dfx Glide General Public License, 3Dfx Interactive Inc.
Group:		X11/Libraries
Source0:	cvs://anonymous@cvs.glide.sourceforge.net:/cvsroot/glide/glide3x-%{snapdate}.tar.gz
# Source0-md5:	42a8e093221b2360ec96191ae0e13ce0
Patch0:		glide-ia64.patch
Patch1:		glide-ac-workaround.patch
Patch2:		glide-h3.patch
Patch3:		glide-h5.patch
Patch4:		glide-am16.patch
Patch5:		glide-gcc33.patch
Patch6:		glide-ioctl.patch
Patch7:		glide-morearchs.patch
Patch8:		glide-gcc34.patch
Patch9:		glide-gcc4.patch
Patch10:	glide-no_redefine_macro.patch
Patch11:	glide-format.patch
Patch12:	glide-include.patch
URL:		http://glide.sourceforge.net/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXxf86dga-devel
BuildRequires:	xorg-lib-libXxf86vm-devel
Provides:	Glide3-DRI
Obsoletes:	Glide_V5-DRI
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This library allows the user to use a 3dfx Interactive Voodoo Banshee
or Voodoo3 card under Linux with DRI support. The source support DRI
or non-DRI versions of Glide.

%description -l pl.UTF-8
Ta biblioteka pozwala użytkownikowi na używanie kart 3dfx Interactive
Voodoo Banshee lub Voodoo3 pod Linuksem z DRI. Ta wersja zawiera
wsparcie dla wersji Glide z DRI i bez DRI.

%package devel
Summary:	Development headers for Glide 3.x
Summary(pl.UTF-8):	Pliki nagłówkowe Glide 3.x
Group:		X11/Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	Glide3x_SDK >= %{epoch}:%{version}
Provides:	Glide3-DRI-devel = %{version}
Obsoletes:	Glide_V5-DRI-devel

%description devel
This package includes the headers files, documentation, and test files
necessary for developing applications that use the 3Dfx Interactive
Voodoo Banshee or Voodoo3 cards.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe, dokumentacje, oraz pliki tekstowe
wymagane przez aplikacje deweloperskie, które używają kart 3Dfx
Interactive Voodoo Banshe lub Voodoo3.

%package static
Summary:	Static library Glide 3.x
Summary(pl.UTF-8):	Statyczne biblioteki Glide 3.x
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	Glide3-DRI-static = %{version}
Obsoletes:	Glide_V5-DRI-static

%description static
This package includes the static Glide3 library for Voodoo Banshee or
Voodoo3 cards.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczne biblioteki Glide3 dla kart Voodoo Banshee
lub Voodoo3.

%package -n Glide3x_SDK
Summary:	Development libraries for Glide 3.x
Summary(pl.UTF-8):	Część Glide 3.x przeznaczona dla programistów
Group:		Development/Libraries
Conflicts:	Glide_SDK

%description -n Glide3x_SDK
This package includes the header files and test files necessary for
developing applications that use any of the 3D accelerators in the
3Dfx Interactive Voodoo line utilizing Glide 3.x interface.

%description -n Glide3x_SDK -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe i pliki testowe potrzebne do
tworzenia aplikacji korzystających z akceleratorów 3D serii 3Dfx
Interactive Voodoo przy użyciu interfejsu Glide 3.x.

%prep
%setup -q -n glide3x-%{snapdate}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p2
%patch10 -p1
%patch11 -p1
%patch12 -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake} -i
%configure \
	--enable-fx-dri-build \
	--enable-fx-glide-hw=h3 \
	--enable-fx-debug=no \
%ifarch i586 i686 athlon pentium3 pentium4
	--enable-amd3d
%endif

%{__make} -j1 -f makefile.autoconf all \
	GLIDE_DEBUG_GCFLAGS="%{rpmcflags} -fno-expensive-optimizations %{!?debug:-fomit-frame-pointer -ffast-math}" \
	GLIDE_DEBUG_GDEFS="%{!?debug:-DBIG_OPT} %{?debug:-DGDBG_INFO_ON -DGLIDE_DEBUG}" \
	LINK_LIBS="-lX11 -lXext -lXxf86dga -lXxf86vm -lm"

%install
rm -rf $RPM_BUILD_ROOT

# something is recompiled - use GCFLAGS too
%{__make} -f makefile.autoconf install \
	GLIDE_DEBUG_GCFLAGS="%{rpmcflags} -fno-expensive-optimizations %{!?debug:-fomit-frame-pointer -ffast-math}" \
	GLIDE_DEBUG_GDEFS="%{!?debug:-DBIG_OPT} %{?debug:-DGDBG_INFO_ON -DGLIDE_DEBUG}" \
	LINK_LIBS="-lX11 -lXext -lXxf86dga -lXxf86vm -lm" \
	DESTDIR=$RPM_BUILD_ROOT

# used by tdfx_dri.so from XFree86
ln -sf libglide3.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libglide3-v3.so
# used by ???
ln -sf libglide3.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libglide3x_V3.so
# used by dlopen in X driver
ln -sf libglide3.so.%{version} $RPM_BUILD_ROOT%{_libdir}/libglide3x.so

%if %{with glide3_sdk}
# Install the examples and their source, no binaries
install -d $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests
install h3/glide3/tests/makefile.distrib $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests/makefile
install h3/glide3/tests/*.3df $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests
install h3/glide3/tests/test??.c $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests
install h3/glide3/tests/tldata.inc $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests
install h3/glide3/tests/tlib.[ch] $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests
gzip -9nf $RPM_BUILD_ROOT%{_examplesdir}/glide3x-%{version}/tests/*.3df
%else
%{__rm} -r $RPM_BUILD_ROOT%{_includedir}/glide3
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc glide_license.txt
%attr(755,root,root) %{_libdir}/libglide3.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libglide3.so.3
%attr(755,root,root) %{_libdir}/libglide3-v3.so
%attr(755,root,root) %{_libdir}/libglide3x.so
%attr(755,root,root) %{_libdir}/libglide3x_V3.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libglide3.so
%{_libdir}/libglide3.la

%files static
%defattr(644,root,root,755)
%{_libdir}/libglide3.a

%if %{with glide3_sdk}
%files -n Glide3x_SDK
%defattr(644,root,root,755)
%{_includedir}/glide3
%{_examplesdir}/glide3x-%{version}
%endif
%changelog
* Tue Sep 24 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Glide_V3-DRI.git;a=log;h=master

* Mon Sep 23 2013 Jakub Bogusz <qboosh@pld-linux.org> 1534f84
- added format patch (fixes build with -Werror=format-security)
- added include patch (avoid includes nested in function)
- rel 17

* Sun Jan 15 2012 Jakub Bogusz <qboosh@pld-linux.org> 18be538
- typos

* Sun Jan 15 2012 Jakub Bogusz <qboosh@pld-linux.org> b220ac2
- moved headers and examples to Glide3_SDK package (disabled by default - normally it will be built from Glide_V5-DRI.spec)

* Sun Jan 08 2012 Jakub Bogusz <qboosh@pld-linux.org> 4592bc0
- merged gcc4 patch and more complete no_redefine_macro patch (based on Debian patches) from Glide_V5-DRI
- dropped buggy gcc 4 parts from gcc34 patch (introduced wrong pointer arithmetic)

* Sat Jan 07 2012 Jakub Bogusz <qboosh@pld-linux.org> a0a5ac0
- make -j1 (some rules are not parallel-ready)
- dropped X11R6 prefix from LINK_LIBS
- ghost soname symlink
- rel 16

* Thu May 19 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 57ec86a
- rel 15

* Sat Jan 29 2011 sparky <sparky@pld-linux.org> c5125e7
- dropped pre-cvs changelog

* Tue Nov 11 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> 1bdcda4
- rel .14

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 0d09113
- tabs in preamle

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 07dcfe4
- converted to UTF-8

* Sat Jan 13 2007 Arkadiusz Miśkiewicz <arekm@maven.pl> 02ad88a
- rel .13

* Thu Jan 04 2007 Szymon Siwek <sls@pld-linux.org> 007f0a6
- removed (duplication of gcc34)

* Thu Jan 04 2007 Szymon Siwek <sls@pld-linux.org> a717a32
- removed patch gcc4 (fixed already in gcc34)

* Wed Jan 03 2007 Szymon Siwek <sls@pld-linux.org> f5a84b6
- added patches gcc4 and no_redefine_macro

* Wed Jan 03 2007 Szymon Siwek <sls@pld-linux.org> 726b015
- added buildfixes

* Sat Dec 23 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 3e091b9
- rel .12; Th deps

* Sat Dec 23 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 0d5ba6e
- more gcc4 stuff

* Sat Jan 21 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 2277660
- kill Icon: field (support for these is obsolete says jbj)

* Sat Jun 19 2004 Jakub Bogusz <qboosh@pld-linux.org> fec5748
- unified examples dir

* Sat Jun 19 2004 Jakub Bogusz <qboosh@pld-linux.org> 8f380d6
- compress *.3df in examples

